//+------------------------------------------------------------------+
//|                                                angle45degree.mq5 |
//|                                  Copyright 2023, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#include <Canvas\iCanvas_CB.mqh> //https://www.mql5.com/ru/code/22164
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit() {
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[]) {
   return(rates_total);
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam) {
   if(id==CHARTEVENT_CHART_CHANGE) Draw();
}
//+------------------------------------------------------------------+
void Draw() {
   double high[], low[];
   CopyHigh(_Symbol,0,(int)W.Right_bar,W.BarsInWind,high);
   CopyLow(_Symbol,0,(int)W.Right_bar,W.BarsInWind,low);
   int i_prmax = ArrayMaximum(high);
   int i_prmin = ArrayMinimum(low);
   int x1 = (int)Canvas.X((double)W.Left_bar-i_prmax);
   int x2 = (int)Canvas.X((double)W.Left_bar-i_prmin);
   int y1 = (int)Canvas.Y(high[i_prmax]);
   int y2 = (int)Canvas.Y(low[i_prmin]);
   double k = fabs(double(y1-y2)/(x1-x2));
   double center_price =W.Y_max - (W.Y_max-W.Y_min)*((y1+y2)/2.0)/W.Height;
   double newMaxPrice =center_price+(W.Y_max-center_price)*k;
   double newMinPrice =center_price-(center_price-W.Y_min)*k;
   Canvas.Erase(0x00FFFFFF);
   uint clrBull=0x8000FF00;
   uint clrBear=0x80FF0000;
   uint clrLine=0xFFFF00FF;
   static MqlRates B[];
   uint clrBody=0;
   CopyRates(_Symbol,_Period,(int)W.Right_bar,W.BarsInWind,B);
   W.Y_max = newMaxPrice;
   W.Y_min = newMinPrice;
   W.dy_pix = (W.Y_max-W.Y_min)/W.Height;
   for(int i=0,x=-1; i<W.BarsInWind; i++,x+=W.dx_pix) {
      Canvas.LineVertical(x,(int)(Canvas.Y(B[i].high)-0.5),(int)(Canvas.Y(B[i].low)-0.5),clrLine);
      if(B[i].close>B[i].open) clrBody=clrBull;
      else if(B[i].close<B[i].open) clrBody=clrBear;
      else clrBody=clrLine;
      Canvas.FillRectangle(x-int(W.dx_pix*0.35),(int)(Canvas.Y(B[i].open)-0.5),x+int(W.dx_pix*0.35),(int)(Canvas.Y(B[i].close)-0.5),clrBody);
   }
   y1 = (int)Canvas.Y(high[i_prmax]);
   y2 = (int)Canvas.Y(low[i_prmin]);
   Canvas.Line(x1,y1,x2,y2,0xFFFF00FF);
   Canvas.Update();
}
//+------------------------------------------------------------------+
